require "jogador"

inimigo = {}
estaVivo = true
persegue = false
rot = 0

inimigo.AnimaTimer = 0
inimigo.pnum = 1
inimigo.speed = math.random(2900,2000)
inimigo.xvel = math.random(200,710)
inimigo.yvel = math.random(50,110)
inimigo.life = 2
inimigo.friction = 0.1
inimigo.timer = 1
inimigo.timerLim = math.random(3,5)
inimigo.amount = math.random(1,10)

inimigoMorto = false
inimigoAnim = {}

inimigoAnim[1] = love.graphics.newImage("recursosAV/inimigo_baixo.png")
inimigoAnim[2] = love.graphics.newImage("recursosAV/inimigo_baixo1.png")
inimigoAnim[3] = love.graphics.newImage("recursosAV/inimigo_baixo2.png")
inimigoAnim[4] = love.graphics.newImage("recursosAV/inimigo_baixo3.png")

inimigoImagem = inimigoAnim[1]


function inimigoSpawn(x, y)
	table.insert(inimigo,{x = x, y = y, xvel = math.random(100,510), yvel = math.random(100,390), 
	life = life, width = inimigo.width, height = inimigo.height})
end

function inimigoGerador(dt)
  inimigo.timer = inimigo.timer + dt
	if inimigo.timer > inimigo.timerLim then
		rot = 0
	for i = 1, inimigo.amount do
		inimigoSpawn(math.random(0,700), math.random(10,30))
			inimigoSpawn(screenWidth / 2  , math.random(5,300))
			inimigoSpawn(screenHeight / 2 , math.random(0,20))
	end
	inimigo.amount = math.random(1,2)
	inimigo.timerLim = math.random(1,4)
	inimigo.timer = 0

	if jogador.pontos > 300 and jogador.pontos < 700 then
         inimigo.amount = math.random(1,3)
	     inimigo.timerLim = math.random(1,5)
	end
	if jogador.pontos > 700 and jogador.pontos < 1000 then
         inimigo.amount = math.random(2,5)
	     inimigo.timerLim = math.random(1,6)
	end
	if jogador.pontos > 1000 and jogador.pontos < 1500 then
         inimigo.amount = math.random(5,10)
	     inimigo.timerLim = math.random(2,8)
	end

	if jogador.pontos > 2000 and jogador.pontos < 3000 then
         inimigo.amount = math.random(7,12)
	     inimigo.timerLim = math.random(3,9)
	end

	if jogador.pontos > 3000  then
         inimigo.amount = math.random(10,15)
	     inimigo.timerLim = math.random(4,10)
	end

end
end


function inimigoDesenha()
     for i,v in ipairs(inimigo) do
     	love.graphics.setColor(math.random(5,255),math.random(240,255),math.random(255,255))
	    love.graphics.draw(inimigoImagem, v.x, v.y,0,1,1,inimigoImagem:getWidth(), 
	    inimigoImagem:getHeight())
	    
	    print("v.y: ".. v.y)
     end
     print("rot"..rot)
     print("jogadorY: ".. jogador.y)
     
end

function inimigoFisica(dt)	
  for i,v in ipairs(inimigo) do
  	if v.y > 650 then table.remove(inimigo,i) end

  	persegue = false
	v.y = v.y + v.yvel * dt
    v.yvel = v.yvel * (1 - math.min(dt*inimigo.friction,1))

   end
end

function inimigoAnimado(dt)

	  inimigoImagem = inimigoAnim[inimigo.pnum]
		inimigo.AnimaTimer = inimigo.AnimaTimer + dt
		if inimigo.AnimaTimer > 0.1 then
			inimigo.pnum = inimigo.pnum + 1
			inimigo.AnimaTimer = 0
		end
		if inimigo.pnum > 4 then
            inimigo.pnum = 1
		end
end


function inimigoAtira(dt)
	for i,v in ipairs(inimigo) do
	if inimigo.timer % 2 == 0 or v.x == jogador.x  then
		  somInimigoAtira:play()
		  somInimigoAtira:setVolume(0.4)
		  somInimigoAtira:setPitch(3)
		  balasInimigasSpawn(v.x + inimigoImagem:getWidth() / 2 - balasInimigasImagem:getWidth() / 2 , v.y - balasInimigasImagem:getHeight(), "down")
	end
  end
end

function colisaoInimigos_balasJogador()
	if estaVivo and gamestate == "playing" then
	for i,v in ipairs(inimigo) do
		for ia,va in ipairs(balas) do
			if detectaColisao(v.x,v.y,inimigoImagem:getWidth(), inimigoImagem:getHeight(),
				va.x,va.y,balasImagem:getWidth(),balasImagem:getHeight()) then
			    explosao_spawn(v.x,v.y)
                table.remove(inimigo,i)
                escudoWidth = escudoWidth + 1.5
                if escudoWidth > 324 then escudoWidth = 325 end
                table.remove(balas,ia)
                somInimigoExplode:play()
                somInimigoExplode:setPitch(3)
                somInimigoExplode:setVolume(0.4)

                escalaX = 1.3
                escalaY = 1.3

                jogador.pontos = jogador.pontos + 1 
            end
		end

		if detectaColisao(v.x,v.y,inimigoImagem:getWidth(), inimigoImagem:getHeight(),
		   jogador.x - (jogadorImagem:getWidth()/2),jogador.y,jogadorImagem:getWidth(),jogadorImagem:getHeight()) then
		    
			explosao_spawn(v.x,v.y)
			escalax = 0.7
	        escalay = 0.7
			somInimigoExplode:play()
			somInimigoExplode:setPitch(3)
			
			table.remove(inimigo, i)
			escudoWidth = escudoWidth - 1.5
			if escudoWidth < 1 then escudoWidth = 0 end

			if not escudo then
			    energiaWidth = energiaWidth - 1.5
			    SomDanoJogador:play()
		    end
            if escudo then 
		       jogador.pontos = jogador.pontos + 1
		    end
		    
			if energiaWidth < 1 then
				     estaVivo = false
				     gamestate = "gameover"
				     explosao_spawn(jogador.x,jogador.y)
                	 somFase1:stop()
                	 table.remove(jogador, i)
                	 SomDanoJogador:setPitch(9)
               	 return
            end
		end
	end
   end
end

----------------------------------Explodindo-----------------------------

explosao = {lista = {}, imagem = love.graphics.newImage("recursosAV/explosao1.png")}

function explosao_spawn(x,y)
	local exp = {}
	exp.x = x
	exp.y = y
	exp.width = 5
	exp.height = 2
	exp.ex = love.graphics.newParticleSystem(explosao.imagem, 10)
	exp.ex:setParticleLifetime(7,10)
	exp.ex:setEmissionRate(2000)
	exp.ex:setSizeVariation(1)
	exp.ex:setLinearAcceleration(-50,50,math.random(3,200),math.random(2,400))
	exp.ex:setColors(math.random(190,255),95,0,155,90,255,0,0)
	table.insert(explosao.lista,exp)

end

function explosao_draw()
	for i, v in ipairs(explosao.lista) do
		love.graphics.draw(v.ex,v.x,v.y)
	end
end

function explosao_update(dt)
	for i, v in ipairs(explosao.lista) do
		v.ex:update(dt)
	end
end

function explosaoDesaparece(dt)

	for i, v in ipairs(explosao.lista) do	 
	   tique.delay(function() table.remove(explosao.lista,exp) end, math.random(5,10)) 	 	    
	end
	
end

	





