--require "balas"
jogador = {}

jogador.AnimaTimer = 0
jogador.pnum = 1

jogador.x = 230
jogador.y = 500
jogadorspeed = 4200
jogadorxvel = 700
jogadoryvel = 700
jogadorfriction = 10
jogador.pontos = 0
highScore = 0

energiaWidth = 325
energiaHeight = 10

escudoWidth = 325
escudoHeight = 10

escudo = false
estaVivo = true

jogadorAnim = {}

jogadorAnim[1] = love.graphics.newImage("recursosAV/naveluz.png")
jogadorAnim[2] = love.graphics.newImage("recursosAV/naveluz1.png")
jogadorAnim[3] = love.graphics.newImage("recursosAV/naveluz2.png")
jogadorAnim[4] = love.graphics.newImage("recursosAV/naveluz3.png")

jogadorAnimR = {}
jogadorAnimL = {}
--Imagens da nave pra direita...
jogadorAnimR[1] = love.graphics.newImage("recursosAV/naveluz_IncDir.png")
jogadorAnimR[2] = love.graphics.newImage("recursosAV/naveluz_IncDir1.png")
jogadorAnimR[3] = love.graphics.newImage("recursosAV/naveluz_IncDir2.png")
jogadorAnimR[4] = love.graphics.newImage("recursosAV/naveluz_IncDir3.png")

--Imagens da nave pra esquerda...
jogadorAnimL[1] = love.graphics.newImage("recursosAV/naveluz_IncEsq.png")
jogadorAnimL[2] = love.graphics.newImage("recursosAV/naveluz_IncEsq1.png")
jogadorAnimL[3] = love.graphics.newImage("recursosAV/naveluz_IncEsq2.png")
jogadorAnimL[4] = love.graphics.newImage("recursosAV/naveluz_IncEsq3.png")


jogadorImagem = jogadorAnim[1]


function jogadorDesenha()
  if estaVivo and gamestate == "playing" then
	love.graphics.setColor(255,255,255)
	love.graphics.draw(jogadorImagem, jogador.x, jogador.y,0,0.9,0.9,jogadorImagem:getWidth(), jogadorImagem:getHeight())
  if love.keyboard.isDown('m') and escudoWidth > 0 then
	love.graphics.setColor(200,math.random(250,200),55,math.random(90,250))
	love.graphics.circle('fill', jogador.x - 22, jogador.y - 23,40,40)
	jogadorspeed = jogadorspeed + escudoWidth 
	somEspecial:play()
	somEspecial:setLooping(true) 
  end
 end
end


function jogadorMove(dt)
	jogadorImagem = jogadorAnim[jogador.pnum]
		jogador.AnimaTimer = jogador.AnimaTimer + dt + 1.5
		if jogador.AnimaTimer > 0.1 then
			jogador.pnum = jogador.pnum + 1
			jogador.AnimaTimer = 0
		end
		if jogador.pnum > 4 then
            jogador.pnum = 1
		end

	if love.keyboard.isDown("w", 'up') and jogadoryvel > - jogadorspeed then
		jogadoryvel = jogadoryvel - jogadorspeed * dt
		
	end
	if love.keyboard.isDown("d", "right") and jogadorxvel < jogadorspeed then
		jogadorImagem = jogadorAnimR[jogador.pnum]
		jogadorxvel = jogadorxvel + jogadorspeed * dt
		
	end
	if love.keyboard.isDown("a", "left") and jogadorxvel > -jogadorspeed then
		jogadorImagem = jogadorAnimL[jogador.pnum]
		jogadorxvel = jogadorxvel - jogadorspeed * dt
		
	end
	if love.keyboard.isDown("s", "down") and jogadoryvel < jogadorspeed then
		jogadoryvel = jogadoryvel + jogadorspeed * dt
	end
	if love.keyboard.isDown('m') then
		escudo = true
        escudoWidth = escudoWidth - 1
        if  escudoWidth < 1 then 
        	escudoWidth = 0 
        	jogadorspeed = 4200 * dt
        	escudo = false
        	somEspecial:stop()
        end
	end
end


function jogadorAtira(key)
  if estaVivo then
	if love.keyboard.isDown ('n') and not balas.especial then
		somTiro:play()
		somTiro:setVolume(0.4)
		somTiro:setPitch(2)
		balasSpawn(jogador.x + jogadorImagem:getWidth() - balasImagem:getWidth() - 13, jogador.y - balasImagem:getHeight(),"up")
	end
	if love.keyboard.isDown ('n') and balas.especial then
		somTiro2:play()
		somTiro2:setVolume(0.4)
		somTiro:setPitch(2)
		balasSpawn(jogador.x + jogadorImagem:getWidth() - balasImagem:getWidth() - 15, jogador.y - balasImagem:getHeight(),"up")

		especialWidth = especialWidth - 3
		if especialWidth < 1 then especialWidth = 0 balas.especial = false end
		
	end
  end
end

function jogadorLimites(dt)

	if escudo then 
			if jogador.x < 0 then jogador.x = screenWidth  jogador.xvel = 0
		end
		    if jogador.y < 0 then jogador.y = screenHeight jogador.yvel = 0
		end 
		    if jogador.x > screenWidth  then jogador.x = 0 jogador.xvel = 0
		end
		    if jogador.y > screenHeight then jogador.y = 0  jogador.yvel = 0
		end 

		else
			
			if jogador.x < 45 then jogador.x = 45  jogador.xvel = 0
		end
		    if jogador.y < 215 then jogador.y = 215 jogador.yvel = 0
		end 
		    if jogador.x > screenWidth  then jogador.x = screenWidth jogador.xvel = 0
		end
		    if jogador.y > screenHeight then jogador.y = screenHeight  jogador.yvel = 0
		end 
	end
end

function jogadorFisica(dt)
	jogador.x = jogador.x + jogadorxvel * dt
	jogador.y = jogador.y + jogadoryvel * dt
	jogadorxvel = jogadorxvel * (1 - math.min(dt*jogadorfriction,1))
    jogadoryvel = jogadoryvel * (1 - math.min(dt*jogadorfriction,1))
end

function colisaoJogador_balasInimigas()
		for ia,va in ipairs(balasInimigas) do
			if detectaColisao(jogador.x - (jogadorImagem:getWidth()/2),jogador.y,jogadorImagem:getWidth(),jogadorImagem:getHeight(),
			   va.x,va.y,balasInimigasImagem:getWidth(),balasInimigasImagem:getHeight()) then
				
              table.remove(balasInimigas,ia)

                if not escudo then
	                energiaWidth = energiaWidth - 1.5
	                SomDanoJogador:play()
	                escalax = 0.7
	                escalay = 0.7
	            end
                if  energiaWidth < 1 then
                	table.remove(jogador, i)
                	SomDanoJogador:play()
                	SomDanoJogador:setPitch(9)
          
                	estaVivo = false
                	gamestate = "gameover"
                	somFase1:stop()
                	somTiro:stop()
                end
            end
		end	
end
    	    	










