

balas = {}
balaswidth = 2.5
balasheight = 175
balas.especial = false
especialWidth = 0
especialHeight = 10

balasImagem = love.graphics.newImage("recursosAV/Shotup.png")

function balasSpawn(x,y,dir)
	table.insert(balas,{x = x, y = y, dir = dir,speed = 500})
end

function balasDraw()
	for i, v in ipairs(balas) do
		
		if balas.especial then
			love.graphics.setColor(math.random(100,155),math.random(50,255),math.random(155,255))
			love.graphics.rectangle('fill',v.x + 10, v.y - 145, balaswidth, balasheight)
			love.graphics.rectangle('fill',v.x - 10, v.y - 145, balaswidth, balasheight)
		else
			love.graphics.setColor(math.random(100,55),math.random(50,255),math.random(55,55))
		    love.graphics.draw(balasImagem,v.x, v.y, 0,0.9,0.9,balasImagem:getWidth()/2, balasImagem:getHeight())
		end
	end
end

function balasMove(dt) 
	for i, v in ipairs(balas) do 

		if v.dir == "up" then 
            v.y = v.y - v.speed * dt
		end
		if v.y < -5 then 
            table.remove(balas, i)
		end
	end	    
end

--/////////////////////////////////////////////////////////////////////////////////////

--Balas inimigas
balasInimigas = {}
balasInimigas.speed = 0
balasInimigasImagem = love.graphics.newImage("recursosAV/tiroInimigo.png")

function balasInimigasSpawn(x,y,dir)
	table.insert(balasInimigas,{x = x, y = y, dir = dir, speed = 800})
end

function balasInimigasDraw()
	for i, v in ipairs(balasInimigas) do
		
		love.graphics.setColor(254,222,1)
		love.graphics.draw(balasInimigasImagem, v.x, v.y,0,1,1, balasInimigasImagem:getWidth()/2, balasInimigasImagem:getHeight())
	
	end
end

function balasInimigasMove(dt) 
	for i, v in ipairs(balasInimigas) do 
		 v.dir = "down"  
         v.y = v.y + v.speed * dt

         if v.y > 600 then 
         	table.remove(balasInimigas, i)
         end
	end
end

function colisaoBalas()
	for i,v in ipairs(balasInimigas) do
		for ia,va in ipairs(balas) do
			if detectaColisao(v.x,v.y,balasInimigasImagem:getWidth(),balasInimigasImagem:getHeight(),
	         va.x,va.y,balasImagem:getWidth(),balasImagem:getHeight()) then
				
				somBalasColidem:play()
                table.remove(balasInimigas,i)
              if not balas.especial then
                table.remove(balas,ia)
              end 
           end
		end
	end
end

