		--Espaço Inimigo _ Top down space shooter --
		require "conf"
		require "jogador"
		require "balas"
		require "inimigo"
		require "menu"
		require "elementos"
	
		tique = require "tick"
	function love.load(arg)
		if gamestate ~= "playing" and gamestate ~= "gameover" then
		   gamestate = "menu"
		end
	        --estaVivo = false      
			if arg and arg[#arg] == "-debug" then require("mobdebug").start() end	

		screenWidth = love.graphics.getWidth()
		screenHeight = love.graphics.getHeight()
		medium = love.graphics.setNewFont("Fonts/Alienscansuckit!.ttf",55)
		small = love.graphics.setNewFont(15)
		fontGamePlay = love.graphics.setNewFont("Fonts/ABBERANC.TTF",15)

		--Carregando recursos de som e imagem...
		somAlarme = love.audio.newSource("recursosAV/somAlarme.mp3","static")
		somInimigoAtira = love.audio.newSource("recursosAV/SomInimigoAtira.mp3")
		somInimigoExplode = love.audio.newSource("recursosAV/SomInimigoExplode.mp3")
		somBalasColidem = love.audio.newSource("recursosAV/SomBalasColidem.mp3")
		SomDanoJogador = love.audio.newSource("recursosAV/SomDanoJogador.mp3")
		SomPowerUp = love.audio.newSource("recursosAV/SompowerupPego.mp3")
		somTiro = love.audio.newSource("recursosAV/EI_jogadoratira.mp3", "static")
		somTiro2 = love.audio.newSource("recursosAV/SomTiro2.mp3", "static")
		somMenu = love.audio.newSource("recursosAV/EI_menutheme.mp3","static")
		somFase1 = love.audio.newSource("recursosAV/mainSongEI.mp3","static")
		somEspecial = love.audio.newSource("recursosAV/SomEspecial.mp3","static")
		zeramentoTema = love.audio.newSource("recursosAV/EI_GRAVAOTHEME.mp3","static")
		cenario = love.graphics.newImage("recursosAV/newspace.jpg")
		cenario2 = love.graphics.newImage("recursosAV/newspace.jpg")
		cenario3 = love.graphics.newImage("recursosAV/newspace.jpg")
		cenarioMenu = love.graphics.newImage("recursosAV/blue_space3a.jpg")
		naveCenario = love.graphics.newImage("recursosAV/navemae_fundo.png")
		fundoGameover = love.graphics.newImage("recursosAV/panoFundoGameover.jpg")
		--cenaFinal = love.graphics.newImage("recursosAV/lael.jpg")
        
		botao_spawn(133,475, "Ajuda", "help")
		botao_spawn(133,425, "Jogar","start")
		botao_spawn(155,525, "Sair", "sair" )
 
	        planodeFundo = {
	           x = 0, y = 0, y2 = 0 - cenario:getHeight() , y3 = cenario2:getHeight(),vel = 10
	       }

	       escalaX,escalaY = 1,1
	       escalax,escalay = 1,1

		 terra.spawn(70,610)
	     sol.spawn(300,100)
	
		 estrelas.spawn(math.random(0,1024), 300)
		 power_up.spawn(math.random(0,1024), math.random(3,600))

		    pontos = {}
		    print(tostring(love.filesystem.getSaveDirectory()))
		    

			if not love.filesystem.exists("pontos.txt") then
				pontos = love.filesystem.newFile("pontos.txt")
			end

			love.filesystem.write("pontos.txt","jogador.highScore: ".. highScore)
			jogador.highScore = pontos[1]

			
			for lines in love.filesystem.lines("pontos.txt") do
				table.insert(pontos,lines)
			end

    end

    function love.update(dt)
    	tique.update(dt)
		if jogador.pontos > tonumber(highScore) then
		                highScore = jogador.pontos
		                love.filesystem.write("pontos.txt","jogador.highScore: "..highScore)
		end

        if gamestate == "playing" and estaVivo then
		    rolagemPlanoFundo(dt)
		    efeitos(dt)
		    efeitosLife(dt)
			sol.fisica(dt)
			estrelas.gerador(dt)
			estrelas.fisica(dt)
			terra.fisica(dt)
			jogadorMove(dt)
			jogadorFisica(dt)
			inimigoFisica(dt)
			inimigoAnimado(dt)
			inimigoAtira(dt)
			colisaoInimigos_balasJogador()
			colisaoJogador_balasInimigas()
			colisaoBalas()
			inimigoGerador(dt)
			power_up.gerador(dt)
			balasMove(dt)
			balasInimigasMove(dt)
			jogadorLimites(dt) 
			power_up_pego(dt)
			power_up.fisica(dt)
			explosao_update(dt)
			explosaoDesaparece(dt)
			
	    end

	    if gamestate == "gameover" and not estaVivo then
	    	--Reseta jogo, em caso de gameover!
		                 reset()	
		end

	    if gamestate == "menu" then
            --Desenha menu, ao iniciar o jogo!
			mousx = love.mouse.getX(dt)
			mousy = love.mouse.getY(dt)
                estaVivo = false
				botao_check(dt)
			    somMenu:play()
			    somMenu:setLooping(true)
			    somMenu:setVolume(0.3)
	    end		
    end

	function love.draw()
		if gamestate == "playing" and estaVivo then  
			 --Panos de fundo da função rolagemPlanoFundo(dt)
		  	love.graphics.setColor(255,255,255)
		  	love.graphics.draw(cenario, planodeFundo.x, planodeFundo.y)
	        love.graphics.draw(cenario2, planodeFundo.x, planodeFundo.y2)
	        love.graphics.draw(cenario3, planodeFundo.x, planodeFundo.y3)
             
             sol_draw()
             terra_draw()
             inimigoDesenha()
             explosao_draw()
             jogadorDesenha()
             estrelasDraw()
             balasDraw()
             balasInimigasDraw()
		     power_up_draw()
			 
		     --Pontuação,energia e escudo, na tela!
			 love.graphics.setColor(198,198,198,200)
			 love.graphics.setFont(fontGamePlay)
			 love.graphics.print("Energia" ,10, 6 , 0, escalax,escalay,5,5,0,0)
			 love.graphics.print("Pontos: "..jogador.pontos,5,49,0,escalaX,escalaY,5,5,0,0) 
			 love.graphics.print("Hi-Score: "..highScore, 1, 59)
			 love.graphics.print("Especial", 4,22)

			 --energy bar
			 love.graphics.setColor(151,255,177,200)
			 love.graphics.rectangle('fill', 60,5,energiaWidth,energiaHeight)
			 love.graphics.setColor(151,255,177,200)
			 love.graphics.rectangle('line', 60,5,325,10)
			 if energiaWidth <= 100  then 
			 love.graphics.setColor(math.random(155,255),0,0,200)
			 love.graphics.rectangle('fill', 60,5,energiaWidth,energiaHeight)
			 love.graphics.setColor(151,255,177,200)
			 love.graphics.rectangle('line', 60,5,325,10)
			 somAlarme:play()
			 somAlarme:setLooping(true)
			 somAlarme:setVolume(0.5)
			 end

             --barra de escudo
			 love.graphics.setColor(15,255,225,math.random(200,250))
			 love.graphics.rectangle('fill', 60,25,escudoWidth,escudoHeight)
			 
			 love.graphics.setColor(15,255,255,200)
			 love.graphics.rectangle('line', 60,25,325,10)

			 --barra de tiro especial
			 love.graphics.setColor(255,255,255)
			 love.graphics.setFont(fontGamePlay)
			 love.graphics.print("SuperBala", 45, 582)
			if balas.especial then 
			 love.graphics.setColor(255,255,10,math.random(1,5))
			 love.graphics.setFont(fontGamePlay)
			 love.graphics.print("SuperBala", 45, 582)
			end

             love.graphics.setColor(255,255,255)
			 love.graphics.rectangle('line', 2,585, 150,10)
			 love.graphics.setColor(255,249,math.random(121,130),math.random(190,290))
			 love.graphics.rectangle('fill', 2,585, especialWidth,especialHeight)
                

    end

			 if gamestate == "menu" and not estaVivo then  
		       --Desenha cenario
		     love.graphics.setColor(255,255,255)
		     love.graphics.draw(cenarioMenu)
		     love.graphics.setColor(math.random(100,255),255,255)
		     love.graphics.draw(naveCenario,1,120)
		     
		     --Desenha botao na tela
			 botao_draw()  
             --Titulo na tela menu.
		     love.graphics.setColor(math.random(100,255),250,math.random(0,255))
			 love.graphics.setFont(medium)
			 love.graphics.print("Espaço Inimigo", 20,50,0,1.1)

			 love.graphics.setColor(255,255,255)
			 love.graphics.setFont(small)
			 love.graphics.print("@copyrights Laires A. Sales.", 5,580) 
              
	 
		    end
			 
			 if gamestate == "gameover" and not estaVivo then
			 	--Desenha tela de game over caso gamestate = gameover e estavivo = false
			 	love.graphics.setBackgroundColor(255,255,255)
			 	love.graphics.draw(cenario)

			 	love.graphics.setBackgroundColor(255,255,255)
			 	love.graphics.draw(fundoGameover,0,350)
			 	                 
			   	love.graphics.setFont(medium)
			    love.graphics.setColor(255,0,0)
				love.graphics.print("\t\tGAME OVER\n", -50, 130)

				love.graphics.setFont(fontGamePlay)
				love.graphics.setColor(math.random(100,55),45,255)
				--love.graphics.print("\t\t\tObrigado por jogar!", 25, 220)
				love.graphics.print("Sua pontuação final foi "..jogador.pontos.. " pontos!", 75, 250)

				love.graphics.print("Supere-se...", 75, 280)
				love.graphics.print("Return... to game!", 120, 350)
                --Mosra pontuação na tela
				--love.graphics.print("Pontuação maxima: "..highScore.." pontos!", 50, 490)  	
		   end
	end

		function reset()
		    if not estaVivo and gamestate == "gameover" then
 			    if love.keyboard.isDown('return') then
		         gamestate = "playing"
		         estaVivo = true
		        -- jogador = {}
		        --jogadorAnim = {}
		        -- jogador.AnimaTimer = 0
		         --jogador.pnum = 1
		         --inimigo = {}
		        -- inimigoAnim = {}
		        -- inimigo.AnimaTimer = 0
		        -- inimigo.pnum = 1
		         table.remove(inimigo, i)
		         table.remove(power_up,i)
		         table.remove(balasInimigas,i)
		         balas = {}
		         balasInimigas = {}
		         balasEspecial = false
		         jogador.x = 210
		         jogador.y = 580
		         jogador.pontos = 0
		         energiaWidth = 325
		         escudoWidth = 325
		         especialWidth = 0
		         somFase1:play()
		         somAlarme:stop()
		         --button = {}
		         --sol = {}
		         --terra = {}
		         --estrelas = {}
		         --power_up = {} 
	 
		        end
	        end
	    end
	    --[[
         function zerou()
		   if final then
		   	zeramentoTema:pay()
		   	zeramentoTema:setLooping(true)

		   	love.graphics.setBackgroundColor(255,255,255)
			love.graphics.draw(cenaFinal)
			love.graphics.setBackgroundColor(255,255,255)			 	
			 	                 
			   	love.graphics.setFont(medium)
			    love.graphics.setColor(255,0,0)
				love.graphics.print("\t\tPARABÉNS\n", -50, 130)

	        love.graphics.setFont(fontGamePlay)
	        love.graphics.setColor(math.random(100,55),45,255)
	        love.graphics.print("\t\t\tVocê defendeu a terra de seu inimigos\n
	        E conseguiu marcar a pontuação maxima!", 25, 220)
	        love.graphics.print("Sua pontuação final foi "..jogador.pontos.. " pontos!", 75, 250)

		   end
		  end

		   ]]--


	function love.keypressed(key)
		if gamestate == "playing" and estaVivo then
			--Função de tiro do jogador
			    jogadorAtira(key)
		end

	    if key == 'escape' then
		       love.event.push('quit') 
	    end	
	end

	function love.mousepressed(x,y)

		if gamestate == "menu" then
		    botao_click(x, y)
		end

	end


	function love.keyreleased(key)
		if key == "space" then
		        somTiro:pause()
		        --SomPowerUp:pause()
	    end
	    if key == 'm' then
	        	escudo = false
	        	jogadorspeed = 4200
	        	somEspecial:stop()
	    end
    end

		function detectaColisao(x1,y1,w1,h1, x2,y2,w2,h2)
			return x1 < x2 + w2 and 
				   x2 < x1 + w1 and 
				   y1 < y2 + h2 and 
				   y2 < y1 + h1
		end

		function rolagemPlanoFundo(dt)
			planodeFundo.y = planodeFundo.y + planodeFundo.vel * dt
			planodeFundo.y2 = planodeFundo.y2 + planodeFundo.vel * dt
			planodeFundo.y3 = planodeFundo.y3 + planodeFundo.vel * dt

		    if planodeFundo.y > screenHeight then
		    	planodeFundo.y = planodeFundo.y2 - cenario2:getHeight()
		    end	

		    if planodeFundo.y2 > screenHeight then
		    	planodeFundo.y2 = planodeFundo.y3 - cenario3:getHeight()
		    end	
		    if planodeFundo.y3 > screenHeight then
		    	planodeFundo.y3 = planodeFundo.y2 - cenario2:getHeight()
		    end	
       end

       function efeitos(dt)
       	--Efeitos no nome pontuação
			escalaX = escalaX - 3 * dt
			escalaY = escalaY - 3 * dt

			  if escalaX <= 1 then

				  	escalaX = 1
				  	escalaY = 1
	          end     
        end

		function efeitosLife(dt)
			--Efeitos no nome energia

		    escalax = escalax - 3 * dt
			escalay = escalay - 3 * dt

				if escalax <= 1 then
				   escalax = 1
				   escalay = 1
			    end
		end
